# -*- coding: utf-8 -*-
import json
import threading
from funcy import memoize, post_processing, ContextDecorator, monkey
from django.db import DEFAULT_DB_ALIAS
from django.db.models.expressions import F, Expression
from distutils.version import StrictVersion

from cacheops.conf import settings
from cacheops.sharding import get_prefix
from cacheops.redis import redis_client, handle_connection_failure, load_script
from cacheops.signals import cache_invalidated
from cacheops.transaction import queue_when_in_transaction
import cacheops

@monkey(cacheops.invalidation, name='redis_can_unlink')
@memoize
def redis_can_unlink():
    return all([StrictVersion(info['redis_version']) >= StrictVersion('4.0') for info in redis_client.info().values()])
